#include <IRremote.h>
#define IR_RECEIVE_PIN 4

#define ENA A0  // Left motor enable (PWM)
#define ENB A3  // Right motor enable (PWM)
#define in1 A2  // Left motor direction
#define in2 A1  // Left motor direction
#define in3 5   // Right motor direction
#define in4 6   // Right motor direction
int leftSpeed = 0;
int rightSpeed = 0;

int speed = 30;

int tick = 0;

void setup() {
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(ENA, OUTPUT);
  pinMode(ENB, OUTPUT);
  Serial.begin(9600);
  IrReceiver.begin(IR_RECEIVE_PIN);

  Serial.println("Start");
}

void loop() {
  int input;
  if (IrReceiver.decode()) {
    tick = 0;
    IrReceiver.resume();
    input = IrReceiver.decodedIRData.command;
    Serial.println(input);  // Print received IR code to debug
  
  } else {
    input = 0;
  }
  if (input == 8) {
    leftSpeed = speed;
  } else if (input == 66) {
    leftSpeed = -speed;
  } else if (input == 90) {
    rightSpeed = speed;
  } else if (input == 74) {
    rightSpeed = -speed;
  } else if (input == 28) {
    rightSpeed = speed;
    leftSpeed = speed;
  } else if (input == 82) {
    rightSpeed = -speed;
    leftSpeed = -speed;
  } else {
    tick = tick + 1;
    if (tick > 3) {
      leftSpeed = 0;
      rightSpeed = 0;
      //Serial.println("0");
    }
  }

  
  setLeftMotorSpeed(leftSpeed);
  setRightMotorSpeed(rightSpeed);
  
  //Serial.println(leftSpeed);
  //Serial.println(rightSpeed);


  delay(50);  // Let loop run smoothly
}

void setLeftMotorSpeed(int x) {
  x = map(x, -100, 100, -1023, 1023);
  if (x > 0) {  // Forward
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
  } else if (x < 0) {  // Backward
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
  } else {  // Stop
    digitalWrite(in1, LOW);
    digitalWrite(in2, LOW);
  }
  analogWrite(ENA, abs(x));
}

void setRightMotorSpeed(int x) {
  x = map(x, -100, 100, -1023, 1023);
  if (x > 0) {  // Forward
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);
  } else if (x < 0) {  // Backward
    digitalWrite(in3, HIGH);
    digitalWrite(in4, LOW);
  } else {  // Stop
    digitalWrite(in3, LOW);
    digitalWrite(in4, LOW);
  }
  analogWrite(ENB, abs(x));
}